<HTML>
<HEAD>

<TITLE>HEPiX Shells Scripts - Files (27-Jun-1996)</TITLE>
<!-- Changed by: Arnaud Taddei,  8-Jul-1996 -->

</HEAD>
<BODY>

<H1>HEPiX Shells Scripts - Files</H1>

<P> <HR> <P>

<P> This page describes the different files used by the HEPiX Shells
Scripts. You can
consult the <A HREF="anatomy.html">anatomy page</A> to have a complete
description of the behaviour.

<P> Some files can be used to customise the
the behaviour of the HEPiX Shell Scripts
(at user, group, system, cluster or site level).

<P> Index: <A HREF="#$HOME/.BackSpace">$HOME/.BackSpace</A> - <A HREF="#$HOME/.Delete">$HOME/.Delete</A> - <A HREF="#$HOME/.hepix/preferred-group">$HOME/.hepix/preferred-group</A> - <A HREF="#*aliases.[c]sh">*aliases.[c]sh</A> - <A HREF="#*env.[c]sh">*env.[c]sh</A> - <A HREF="#*login.[c]sh">*login.[c]sh</A> - <A HREF="#*rc*">*rc*</A> - <A HREF="#*sys.conf.[c]sh">*sys.conf.[c]sh</A> - <A HREF="#^?">^?</A> - <A HREF="#central-templates">central-templates</A> - <A HREF="#HEP_bashrc">HEP_bashrc</A> - <A HREF="#HEP_csh.cshrc">HEP_csh.cshrc</A> - <A HREF="#HEP_csh.login">HEP_csh.login</A> - <A HREF="#HEP_cshrc.rc">HEP_cshrc.rc</A> - <A HREF="#HEP_kshrc">HEP_kshrc</A> - <A HREF="#HEP_profile">HEP_profile</A> - <A HREF="#HEP_tcshrc">HEP_tcshrc</A> - <A HREF="#HEP_zprofile">HEP_zprofile</A> - <A HREF="#HEP_zshenv">HEP_zshenv</A> - <A HREF="#HEP_zshrc">HEP_zshrc</A> - <A HREF="#HEPiX Shell Scripts Files">HEPiX Shell Scripts Files</A> - <A HREF="#Other Files">Other Files</A> - <A HREF="#Templates">Templates</A> - <A HREF="#termset.[c]sh">termset.[c]sh</A> - <A HREF="#User files">User files</A> - <A HREF="#Wrapper Files">Wrapper Files</A>

<P> <HR> <P>


<H2>Normal behaviour of the shells</H2>
 <P>
In order to understand the layout of our proposed scripts it is necessary 
to understand which files are executed by default by a given shell.
 <P>
Standard configuration files for the different shells
<PRE>
Shell		Conditions		Executed scripts
=============================================================================
csh             always			$HOME/.cshrc
                login			$HOME/.login
-----------------------------------------------------------------------------
tcsh		always			/etc/csh.cshrc
		login			/etc/csh.login or $HOME/.login
		interactive		$HOME/.tcshrc or $HOME/.cshrc
-----------------------------------------------------------------------------
ksh		always			ENV variable if set
		login			/etc/profile or $HOME/.profile
		interactive		$HOME/.kshrc
-----------------------------------------------------------------------------
zsh		always			/etc/zshenv
					$HOME/.zshenv
		login			/etc/zprofile
					$HOME/.zprofile
					$HOME/.zlogin
		interactive		/etc/zshrc
					$HOME/.zshrc
-----------------------------------------------------------------------------
bash		always			not possible
		login			/etc/profile
					$HOME/.bash_profile or $HOME/.profile
		interactive		$HOME/.bashrc
		non-interactive		ENV variable if set
=============================================================================
</PRE>

<P> <HR> <P>

<H2><A NAME="Wrapper Files">Wrapper Files</A></H2>

 <P>
Files used in enforced mode  to call 
the HEP scripts and to make sure that 
 root and other users don't use the HEP scripts.
 <P>
The wrappers are a set of 10 files which are replacing the vendor supplied
shell startup-files under /etc. You can read them into the 
repository /usr/local/lib/hepix/shells/wrappers\\

 <P>
Location: /etc
 <P>
No customisation is possible here
 <P>
Wrappers provided with the HEPiX scripts
<PRE>

Conditions		Bourne shell flavor		C shell flavor
=============================================================================
always			/etc/zshenv			/etc/cshrc
-----------------------------------------------------------------------------
login			/etc/zprofile			/etc/csh.login
			/etc/profile              
-----------------------------------------------------------------------------
interactive		ksh: /etc/kshrc			csh: /etc/csh.cshrc
			bash:/etc/bashrc		tcsh:/etc/tcshrc 
			zsh: /etc/zshrc 
=============================================================================
</PRE>

<P> <HR> <P>

<H2><A NAME="central-templates">central-templates</A></H2>
 <P>
Files used in mode 1 (see installation) to call 
the HEP scripts and to make sure that the latter haven't been used 
already (see protection variables).
 <P>
These files are the one directly called by the templates.
 <P>
There are 4 files: 
 <P>
central_env.csh, 
central_login.csh, 
central_env.sh, 
central_login.sh.
 <P>
They are located in /usr/local/lib/hepix and they are called by the
templates.


<P> <HR> <P>

<H2><A NAME="HEPiX Shell Scripts Files">HEPiX Shell Scripts Files</A></H2>

<P> Here are the default locations for these files:
<UL>
<LI> user:    <CODE>$HOME</CODE> and <CODE>$HOME/.hepix</CODE>
<LI> group:   <CODE>$GROUP_DIR</CODE>
<LI> system:  <CODE>/etc/hepix</CODE>
<LI> cluster: <CODE>/etc/hepix/cluster</CODE>
<LI> site:    <CODE>/usr/local/lib/hepix/shells/site</CODE>
<LI> hep:     <CODE>/usr/local/lib/hepix/shells/hep</CODE>
</UL>

<P> Note that the group level default location depends on the variable
GROUP_DIR that should be defined on the Site level
 <P>
The HEP files are the main engine they are calling all the other files to
provide the hooks to the Site level files, set some variables, etc.
 <P>
<B><CODE><A NAME="HEP_csh.cshrc">HEP_csh.cshrc</A></CODE></B>
 <P>
This file sets the environment of the C shells. 
It mainly provides almost all the useful environment variables.
 <P>
<B><CODE><A NAME="HEP_zshenv">HEP_zshenv</A></CODE></B>
 <P>
The same as above but for Bourne Shells
 <P>
<B><CODE><A NAME="HEP_csh.login">HEP_csh.login</A></CODE></B>
 <P>
This file configures the login part of the C shells, setting the terminal
line if connected to a terminal, etc.
 <P>
<B><CODE><A NAME="HEP_profile">HEP_profile</A></CODE></B>
 <P>
The same as above but for sh, ksh, bash.
 <P>
<B><CODE><A NAME="HEP_zprofile">HEP_zprofile</A></CODE></B>
 <P>
The same as above but for zsh.
 <P>
<B><CODE><A NAME="HEP_cshrc.rc">HEP_cshrc.rc</A></CODE></B>
 <P>
This file is setting some specific default for csh. For instance,
setting some options, some shell variables, some aliases and/or functions, 
etc.
 <P>
<B><CODE><A NAME="HEP_tcshrc">HEP_tcshrc</A></CODE></B>
 <P>
Same as above but for tcsh.
 <P>
<B><CODE><A NAME="HEP_kshrc">HEP_kshrc</A></CODE></B>
 <P>
Same as above but for ksh.
 <P>
<B><CODE><A NAME="HEP_bashrc">HEP_bashrc</A></CODE></B>
 <P>
Same as above but for bash.
 <P>
<B><CODE><A NAME="HEP_zshrc">HEP_zshrc</A></CODE></B>
 <P>
Same as above but for zsh.
 <P>
<HR>
 <P>
<H3>Files at other levels</H3>
 <P>
<B><CODE><A NAME="*sys.conf.[c]sh">*sys.conf.[c]sh</A></CODE></B>
 <P>
These files are used to set ONLY the environment variables. There are two 
"twin" files for eboth C-shell and Bourne shell flavour and one
is the translation of the other.
 <P>
<B><CODE><A NAME="*env.[c]sh">*env.[c]sh</A></CODE></B>
 <P>
These files are here to set the environnment part of the shell.
 <P>
<B><CODE><A NAME="*aliases.[c]sh">*aliases.[c]sh</A></CODE></B>
 <P>
These files are provided for you to give some aliases or functions.
 <P>
<B><CODE><A NAME="*rc*">*rc*</A></CODE></B>
 <P>
These files are here to put all other shell variables you need or other
options, etc. which affect the behaviour of the shell itself.
 <P>
<B><CODE><A NAME="*login.[c]sh">*login.[c]sh</A></CODE></B>
 <P>
These files are provided for you to set everything which occurs at login 
time.
 <P>
<B><CODE><A NAME="termset.[c]sh">termset.[c]sh</A></CODE></B>
 <P>
These files are provided for term setting corrections

<P> <HR> <P>

<H1><A NAME="Other Files">Other Files</A></H1>

<P> Here are some other files that have not been described above.

<H2><CODE><A NAME="$HOME/.BackSpace">$HOME/.BackSpace</A></CODE></H2>

<P> It is used by the <A HREF="./..">HEPiX scripts</A> (both X11 and shells) to properly bind the
"erase" key to backspace (<CODE><A NAME="^?">^?</A></CODE>).

<H2><CODE><A NAME="$HOME/.Delete">$HOME/.Delete</A></CODE></H2>

<P> It is used by the <A HREF="./..">HEPiX scripts</A> (both X11 and shells) to properly bind the
"erase" key to delete (<CODE>^H</CODE>).

<H2><CODE><A NAME="$HOME/.hepix/preferred-group">$HOME/.hepix/preferred-group</A></CODE></H2>
 <P>
<H2><A NAME="Templates">Templates</A></H2>
 <P>
Located at /usr/local/lib/hepix/templates
 <P>
	shell user files .login, .cshrc, etc.
 <P>
They consists of 3 parts
<UL>
<LI> a header which provides contact names, description, etc.,
<LI> a call to a file /usr/local/lib/hepix/central_*.[c]sh where 
* could be env or login.
<LI> a body full of comments to help you setting your environment.
</UL>
 <P>
The document 170, 171, 172 and 175 are short documents which explain some
issues with the setting of the PATH (document 170), the setting
of options for zsh (document 175), where you can run commands which 
produce an output on the terminal (document 171 for zsh and 172 for
tcsh).
 <P>
The following table provides the names of the configuration files you can
use according to your shell:
<H2><A NAME="User files">User files</A></H2>
 <P>
Standard users dot-files
 <PRE>
Shell		Conditions		Executed dot files
=============================================================================
csh             always			.cshrc
                login			.login
-----------------------------------------------------------------------------
tcsh            always			.tcshrc or
					.cshrc
                login			.login
-----------------------------------------------------------------------------
ksh             login			.profile
                interactive		.kshrc
-----------------------------------------------------------------------------
zsh		always			.zshenv
		login			.zprofile and .zlogin
		interactive		.zshrc
-----------------------------------------------------------------------------
bash		login			.bash_profile or
					.profile
=============================================================================
</PRE>

<P> <HR> <P>
<ADDRESS> <A Name=Signature HREF="http://xwho.cern.ch/WHO/people/26840">Arnaud Taddei</A>,  8-Jul-1996</ADDRESS>
</BODY>
</HTML>











